unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, StdCtrls, OleCtrls, SHDocVw, ExtCtrls, FileCtrl,
  Buttons, Menus, ActnList, Registry;

type
  TMainF = class(TForm)
    PageControl: TPageControl;
    Text: TTabSheet;
    HTML: TTabSheet;
    StatusBar: TStatusBar;
    Edit: TRichEdit;
    Panel: TPanel;
    Browser: TWebBrowser;
    ButtonPanel: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    MainMenu1: TMainMenu;
    miFile: TMenuItem;
    miEdit: TMenuItem;
    miOptions: TMenuItem;
    miHelp: TMenuItem;
    miSearch: TMenuItem;
    Bevel1: TBevel;
    Bevel2: TBevel;
    miNew: TMenuItem;
    miOpen: TMenuItem;
    miSave: TMenuItem;
    miSaveAs: TMenuItem;
    miBrake1: TMenuItem;
    miExit: TMenuItem;
    miUndo: TMenuItem;
    miBrake2: TMenuItem;
    miCut: TMenuItem;
    miCopy: TMenuItem;
    miPaste: TMenuItem;
    miBrake3: TMenuItem;
    miSellectAll: TMenuItem;
    miFind: TMenuItem;
    miFindMore: TMenuItem;
    miReplace: TMenuItem;
    miMainset: TMenuItem;
    miAbout: TMenuItem;
    ActionList: TActionList;
    New: TAction;
    Open: TAction;
    OpenDialog: TOpenDialog;
    Save: TAction;
    SaveAs: TAction;
    SaveDialog: TSaveDialog;
    Exit: TAction;
    Undo: TAction;
    Cut: TAction;
    aCopy: TAction;
    Paste: TAction;
    SelectAll: TAction;
    miWordWrap: TMenuItem;
    WordWrap: TAction;
    Find: TAction;
    FindMore: TAction;
    Replace: TAction;
    miInserting: TMenuItem;
    miHTMLStart: TMenuItem;
    miDate: TMenuItem;
    miTime: TMenuItem;
    HTMLstart: TAction;
    DateAndTime: TAction;
    miDateTime: TMenuItem;
    Date: TAction;
    TimeA: TAction;
    StandartOptions: TAction;
    aAbout: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Font: TAction;
    bgcolor: TAction;
    others: TAction;
    Preview: TAction;
    procedure NewExecute(Sender: TObject);
    procedure OpenExecute(Sender: TObject);
    procedure SaveExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SaveAsExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ExitExecute(Sender: TObject);
    procedure CutExecute(Sender: TObject);
    procedure aCopyExecute(Sender: TObject);
    procedure PasteExecute(Sender: TObject);
    procedure SelectAllExecute(Sender: TObject);
    procedure WordWrapExecute(Sender: TObject);
    procedure FindExecute(Sender: TObject);
    procedure FindMoreExecute(Sender: TObject);
    procedure ReplaceExecute(Sender: TObject);
    procedure UndoExecute(Sender: TObject);
    procedure RedoExecute(Sender: TObject);
    procedure HTMLstartExecute(Sender: TObject);
    procedure DateAndTimeExecute(Sender: TObject);
    procedure DateExecute(Sender: TObject);
    procedure TimeAExecute(Sender: TObject);
    procedure StandartOptionsExecute(Sender: TObject);
    procedure RegRead;
    procedure RegWrite;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageControlChange(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure EditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditSelectionChange(Sender: TObject);
    procedure CurWrite;
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure aAboutExecute(Sender: TObject);
    procedure FontExecute(Sender: TObject);
    procedure bgcolorExecute(Sender: TObject);
    procedure othersExecute(Sender: TObject);
    procedure PreviewExecute(Sender: TObject);
  private

  public
    reg		:TRegistry;
  end;
var
  MainF		:TMainF;
  filename	:string;
  TSO		:TSearchTypes;
  f		:text;
  TestHTML	:string='';

implementation

uses UFindDialog, UReplaceDialog, UMainSet, RichEdit, UAbout;
{$R *.DFM}
procedure TMainF.RegRead;
begin
try
  reg:=TRegistry.Create;
  reg.LazyWrite:=true;
  reg.RootKey:=HKEY_CURRENT_USER;
  reg.openkey('SOFTWARE',True);
  reg.openkey('KEYER',True);
  reg.openkey('KoEdit',True);
  reg.OpenKey('MainSet',True);
  if Reg.ValueExists('BgC') then Edit.Color:=Reg.ReadInteger('BgC') //  
     Else Reg.WriteInteger('BgC',Edit.Color);
  if Reg.ValueExists('FC') then Edit.Font.Color:=Reg.ReadInteger('FC') // 
     Else Reg.WriteInteger('FC',Edit.Font.Color);
  if Reg.ValueExists('FS') then Edit.Font.Size:=Reg.ReadInteger('FS')  // 
     Else Reg.WriteInteger('FS',Edit.Font.Size);
  if Reg.ValueExists('FN') then Edit.Font.Name:=Reg.ReadString('FN')  // 
     Else Reg.WriteString('FN',Edit.Font.Name);
  if Reg.ValueExists('fsBold') then                                   //fsBold
     begin
       if Reg.ReadBool('fsBold') then Edit.Font.Style:=Edit.Font.Style+[fsBold]
     end
       else
         Reg.WriteBool('fsBold',false);
  if Reg.ValueExists('fsItalic') then                                   //fsItalic
     begin
       if Reg.ReadBool('fsItalic') then Edit.Font.Style:=Edit.Font.Style+[fsItalic]
     end
       else
         Reg.WriteBool('fsItalic',false);
  if Reg.ValueExists('fsUnderline') then                                   //fsUnderline
     begin
       if Reg.ReadBool('fsUnderline') then Edit.Font.Style:=Edit.Font.Style+[fsUnderline]
     end
       else
         Reg.WriteBool('fsUnderline',false);
  if not Reg.ValueExists('SWinP') then Reg.WriteBool('SWinP',true);
  if not Reg.ReadBool('SWinP') then Position:=poDesktopCenter;
  if Reg.ValueExists('WinPosX') Then                                        //   OX
     begin
       If Reg.ReadBool('SwinP') then
         MainF.Left:=Reg.ReadInteger('WinPosX')
     end
       else
         Reg.WriteInteger('WinPosX',MainF.Left);
  if Reg.ValueExists('WinPosY') Then                                        //   OY
     begin
       If Reg.ReadBool('SwinP') then
         MainF.Top:=Reg.ReadInteger('WinPosY')
     end
       else
         Reg.WriteInteger('WinPosY',MainF.Top);
  if Reg.ValueExists('WinH') Then                                           // 
     begin
       If Reg.ReadBool('SwinP') then
         MainF.Height:=Reg.ReadInteger('WinH')
     end
       else
         Reg.WriteInteger('WinH',MainF.Height);
  if Reg.ValueExists('WinW') Then                                        // 
     begin
       If Reg.ReadBool('SwinP') then
         MainF.Width:=Reg.ReadInteger('WinW')
     end
       else
         Reg.WriteInteger('WinW',MainF.Width);
  if Reg.ValueExists('WW') then
    begin
      if Reg.ReadBool('WW') then WordWrapExecute(Self)
    end
      else
        Reg.WriteBool('WW',false);
  if not Reg.ValueExists('Bak') then Reg.WriteBool('Bak',false);{ TODO 4 -oKeyer -cKoEdit :   bak  }
except
   raise
end
end;
procedure TMainF.RegWrite;
begin
try
  Reg.WriteInteger('BgC',Edit.Color);
  Reg.WriteInteger('FC',Edit.Font.Color);
  Reg.WriteInteger('FS',Edit.Font.Size);
  Reg.Writestring('FN',Edit.Font.Name);
  if fsBold in Edit.Font.Style then Reg.WriteBool('fsBold',true) else Reg.WriteBool('fsBold',false);
  if fsItalic in Edit.Font.Style then Reg.WriteBool('fsItalic',true) else Reg.WriteBool('fsItalic',false);
  if fsUnderline in Edit.Font.Style then Reg.WriteBool('fsUnderline',true) else Reg.WriteBool('fsUnderline',false);
  Reg.WriteInteger('WinPosX',MainF.Left);
  Reg.WriteInteger('WinPosY',MainF.Top);
  Reg.WriteInteger('WinH',MainF.Height);
  Reg.WriteInteger('WinW',MainF.Width);
  Reg.WriteBool('WW',Edit.WordWrap);
except
    raise
end;
  Reg.Free;
end;
//-----------------------------------------------------------------------------
                        //,,, 
procedure TMainF.FormCreate(Sender: TObject);
label ass;
begin
  RegRead;
  filename:='.txt';
//--------
  if (paramCount<>0)and(paramStr(1)<>'') then
    begin
      if FileExists(paramStr(1)) then
        begin
          filename:=paramStr(1);
          Edit.Lines.LoadFromFile(filename);
          StatusBar.Panels[2].text:=filename;
          Edit.Modified:=false;
          StatusBar.Panels[1].text:='';
        end
    end
      else
        begin
          StatusBar.Panels[0].text:='1 : 1';
          StatusBar.Panels[2].text:=Filename;
        end;
  Caption:='KoEdit - '+'['+extractFilename(filename)+']';
end;

procedure TMainF.NewExecute(Sender: TObject); //!!!
var rez:TModalResult;
procedure NewNow;
begin
  Edit.Text:='';
  filename:='.txt';
  Caption:='KoEdit - '+'['+filename+']';
  Edit.Modified:=false;
  StatusBar.Panels[2].text:=filename;
  StatusBar.Panels[1].text:='';
  StatusBar.Panels[0].text:='1 : 1';
end;
begin
  if Edit.Modified then
         begin
           rez:=MessageDlg('    '+ExtractFilename(FileName)+'?',mtCustom,[mbYes,mbNo,mbCancel],0);
           if rez=mrYes
              then
                begin
                  SaveExecute(Sender);
                  if not Edit.Modified then
                     NewNow
                end
               else
           if rez=mrNo then
               NewNow
         end
           else
             NewNow
end;

procedure TMainF.OpenExecute(Sender: TObject); //!!!
var rez:TModalResult;
label 1,2;
procedure OpenNow;
begin
  Edit.Lines.LoadFromFile(OpenDialog.Filename);
  filename:=OpenDialog.Filename;
  Caption:='KoEdit - '+'['+ExtractFileName(filename)+']';
  Edit.Modified:=false;
  StatusBar.Panels[2].text:=filename;
  StatusBar.Panels[1].text:='';
end;
begin
  Opendialog.Filter:=' |*.*';
  if Edit.Modified then
     begin
       rez:=MessageDlg('    '+ExtractFilename(FileName)+'?',mtCustom,[mbYes,mbNo,mbCancel],0);
       if (rez=mrYes)or(rez=mrNo) then
          begin
            if rez=mrYes then SaveExecute(Sender);
            if (not Edit.Modified)or(rez=mrNo) then
          1:if OpenDialog.Execute then
              begin
                if FileExists(OpenDialog.Filename) then
                  OpenNow
                    else
                      begin
                        MessageDlg(ExtractFilename(OpenDialog.Filename)+#13#10+'   .'#13#10'   .',mtWarning,[mbOK],0);
                        goto 1;
                      end
              end
          end
     end
       else
         begin
         2:if OpenDialog.Execute then
              begin
                if FileExists(OpenDialog.Filename) then
                  OpenNow
                    else
                      begin
                        MessageDlg(ExtractFilename(OpenDialog.Filename)+#13#10+'   .'#13#10'   .',mtWarning,[mbOK],0);
                        goto 2;
                      end
              end
         end
end;

procedure TMainF.SaveExecute(Sender: TObject); //
begin
  if filename<>'.txt' then
    begin
     Edit.Lines.SaveToFile(filename);
     Edit.Modified:=false;
     StatusBar.Panels[2].text:=filename;
     StatusBar.Panels[1].text:='';
    end
       else
         SaveAsExecute(Sender)
end;

procedure TMainF.SaveAsExecute(Sender: TObject);  // 
var rez:TModalResult;
label ass;
begin
ass:if SaveDialog.Execute then
     begin
       if FileExists(SaveDialog.Filename) then
         begin
           rez:=MessageDlg('"'+SaveDialog.filename+'"'+'  .'#13#10'  ?',mtWarning,[mbYes,mbNo],0);
           if rez=mrNo then goto ass;
         end;
       try
         Edit.Lines.saveToFile(SaveDialog.Filename);
         filename:=SaveDialog.Filename;
         Caption:='KoEdit - '+'['+ExtractFileName(filename)+']';
         Edit.Modified:=false;
         StatusBar.Panels[2].text:=filename;
         StatusBar.Panels[1].text:='';
       except
         on EInOutError do
           begin
             MessageDlg('   !',mtError,[mbOK],0);
             raise;
           end;
       end;
     end;
end;
//------------------------------------------------------------------------------
                            //  
procedure TMainF.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var rez:TModalResult;
begin
  if Edit.Modified then
    begin
      rez:=MessageDlg('    '+ExtractFilename(FileName)+'?',mtCustom,[mbYes,mbNo,mbCancel],0);
      if rez=mrYes then SaveExecute(Sender);
      if rez=mrCancel then Canclose:=false;
    end
end;

procedure TMainF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RegWrite;
  DeleteFile(TestHTML)
end;

procedure TMainF.ExitExecute(Sender: TObject);
begin
  Close;
end;
//------------------------------------------------------------------------------
            //, , , ,  ,   
procedure TMainF.UndoExecute(Sender: TObject);
begin
  Edit.Undo;
end;

procedure TMainF.RedoExecute(Sender: TObject);
begin
  ;
end;

procedure TMainF.CutExecute(Sender: TObject);
begin
  Edit.CutToClipboard
end;

procedure TMainF.aCopyExecute(Sender: TObject);
begin
  Edit.CopyToClipboard
end;

procedure TMainF.PasteExecute(Sender: TObject);
begin
  Edit.PasteFromClipboard
end;

procedure TMainF.SelectAllExecute(Sender: TObject);
begin
  Edit.SelectAll
end;

procedure TMainF.WordWrapExecute(Sender: TObject);
var c:longint;
begin
  c:=Edit.selStart;
  Edit.WordWrap:=not Edit.WordWrap;
  Edit.SelStart:=c;
  miWordWrap.Checked:=not miWordWrap.checked
end;
//------------------------------------------------------------------------------
                         //,  , 
procedure TMainF.FindExecute(Sender: TObject);  //
var start,BeginAt,StopAt:longint;
begin
  FindDialog.Execute;
//---
  if FindDialog.CanFind then
    begin
  if FindDialog.down.checked then
    begin
      BeginAt:=Edit.SelStart;
      StopAt:=length(Edit.Text)
    end
      else
  if FindDialog.up.checked then
    begin
      BeginAt:=0;
      StopAt:=Edit.SelStart
    end
      else
  if FindDialog.all.checked then
    begin
      BeginAt:=0;
      StopAt:=length(Edit.Text)
    end;
  if FindDialog.reg.checked then TSO:=TSO+[stMatchCase] else TSO:=TSO-[stMatchCase];
  if FindDialog.WholeWord.Checked then TSO:=TSO+[stWholeWord] else TSO:=TSO-[stWholeWord];
  if FindDialog.FindText.Text<>'' then
    begin
      start:=longint(Edit.FindText(FindDialog.FinDText.Text,BeginAt,StopAt,TSO));
      if start<>-1 then
         begin
           Edit.HideSelection:=false;
           Edit.SelStart:=start;
           Edit.SelLength:=length(FindDialog.FindText.Text);
         end
           else
             ShowMessage(' "'+FindDialog.findText.Text+'"   !')
    end
    end
end;

procedure TMainF.FindMoreExecute(Sender: TObject); // 
var BeginAt,StopAt,Start:longint;
begin
  if FindDialog.FindText.Text<>'' then
    begin
      if FindDialog.reg.checked then TSO:=TSO+[stMatchCase] else TSO:=TSO-[stMatchCase];
      if FindDialog.WholeWord.Checked then TSO:=TSO+[stWholeWord] else TSO:=TSO-[stWholeWord];
      BeginAt:=Edit.SelStart+Edit.SelLength;
      StopAt:=length(Edit.Text);
      start:=longint(Edit.FindText(FindDialog.FinDText.Text,BeginAt,StopAt,TSO));
      if start<>-1 then
         begin
           Edit.HideSelection:=false;
           Edit.SelStart:=start;
           Edit.SelLength:=length(FindDialog.FindText.Text);
         end
           else
             FindDialog.CanFind:=false
    end
      else
        FindExecute(Sender);
end;

procedure TMainF.ReplaceExecute(Sender: TObject); //
begin
  ReplaceDialog.Execute
end;
//------------------------------------------------------------------------------
             // HTML,   , , 
procedure TMainF.HTMLstartExecute(Sender: TObject);
begin
  NewExecute(Sender);
  Edit.Text:='<HTML>'#13#10'   <HEAD>'#13#10'      <TITLE>..::::::..</TITLE>'#13#10'   </HEAD>'#13#10'   <BODY BGCOLOR="#FFFFFF" TEXT="#000000">'#13#10'         '#13#10'   </BODY>'#13#10'</HTML>';
  Edit.Selstart:=124
end;

procedure TMainF.DateAndTimeExecute(Sender: TObject);
begin
  Edit.SelText:=DateTimeToStr(Now)
end;

procedure TMainF.DateExecute(Sender: TObject);
begin
  Edit.SelText:=DateToStr(Now)
end;

procedure TMainF.TimeAExecute(Sender: TObject);
begin
  Edit.SelText:=TimeToStr(Now)
end;
//----------------------------------------------------------------------------
          //  HTML   PageControl
procedure TMainF.PageControlChange(Sender: TObject);
var s:string;
    i:integer;
begin
if PageControl.ActivePageIndex=1 then
begin
  getDir(0,s);
  if TestHTML='' then
  for i:=1 to MaxInt do
    if not fileExists(s+'\'+'KoEdit'+IntToStr(i)+'$.htm') then
      begin
        TestHTML:=s+'\'+'KoEdit'+IntToStr(i)+'$.htm';
        break
      end;
  Edit.Lines.SaveToFile(TestHTML);
  FileSetAttr(TestHTML,faHidden);
  Browser.Navigate(testHTML);
end
end;
//-----------------------------------------------------------------------------
           // 
procedure TMainF.StandartOptionsExecute(Sender: TObject);
begin
  MainSet.position:=poMainFormCenter;
  MainSet.ShowModal
end;
//------------------------------------------------------------------------------
procedure TMainF.EditChange(Sender: TObject);
begin
  if (Reg.ReadBool('Bak'))and(filename<>'.txt') then
     Edit.Lines.SaveToFile(ChangeFileExt(Filename,'.bak'));
  StatusBar.Panels[1].Text:='';
  CurWrite
end;

procedure TMainF.EditMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CurWrite
end;

procedure TMainF.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CurWrite
end;

procedure TMainF.EditSelectionChange(Sender: TObject);
begin
  CurWrite;
end;
procedure TMainF.CurWrite;
var LineNum,CharNum:longint;
begin
  LineNum := Edit.Perform(EM_LINEFROMCHAR, Edit.SelStart, 0);
  CharNum := Edit.Perform(EM_LINEINDEX, LineNum, 0);
  StatusBar.Panels[0].Text :=IntToStr(LineNum + 1)+' : '+IntToStr((Edit.SelStart+Edit.SelLength - CharNum)+ 1);
end;
//-----------------------------------------------------------------------------
procedure TMainF.EditKeyPress(Sender: TObject; var Key: Char);
var  line, col, indent: integer;
                     S: String;
begin
  if key = #13 then
    begin
      key := #0;
      with sender as TRichEdit do
         begin
          line := PerForm( EM_EXLINEFROMCHAR, 0, SelStart );
          Col  := SelStart - Perform( EM_LINEINDEX, line, 0 );
          S:= Copy( lines[ line ], 1, col );
          indent := 0;
          while (indent < length( S )) and (S[indent + 1] in  [' ', #9]) do
           Inc( indent );
          SelText := #13#10 + Copy(S, 1, indent);
       end;
   end;
end;
//---------------------------------------
procedure TMainF.aAboutExecute(Sender: TObject);
begin
  About.position:=poMainFormCenter;
  About.ShowModal;
end;
//----------------------------------------
procedure TMainF.FontExecute(Sender: TObject);
begin
  MainSet.SetTab.ActivePageIndex:=0;
  StandartOptionsExecute(Sender)
end;

procedure TMainF.bgcolorExecute(Sender: TObject);
begin
  MainSet.SetTab.ActivePageIndex:=1;
  StandartOptionsExecute(Sender)
end;

procedure TMainF.othersExecute(Sender: TObject);
begin
  MainSet.SetTab.ActivePageIndex:=2;
  StandartOptionsExecute(Sender)
end;

procedure TMainF.PreviewExecute(Sender: TObject);
begin
  if pagecontrol.ActivepageIndex=0 then pagecontrol.ActivepageIndex:=1
    else
      pagecontrol.ActivepageIndex:=0; 
  PageControlChange(Self)
end;

end.
