unit UMainSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Buttons,Registry;

type
  TMainSet = class(TForm)
    SetTab: TPageControl;
    Font: TTabSheet;
    Field: TTabSheet;
    Other: TTabSheet;
    OK: TButton;
    Apply: TButton;
    Cancel: TButton;
    FontBox: TComboBox;
    Label1: TLabel;
    FontSize: TEdit;
    UpDown: TUpDown;
    FontColor: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    Bold: TCheckBox;
    Italic: TCheckBox;
    Underlined: TCheckBox;
    Example: TPanel;
    ColorDialog: TColorDialog;
    BgColor: TPanel;
    Label4: TLabel;
    WinPos: TCheckBox;
    Bak: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FontBoxChange(Sender: TObject);
    procedure FontColorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FontSizeChange(Sender: TObject);
    procedure UpDownChanging(Sender: TObject; var AllowChange: Boolean);
    procedure BoldClick(Sender: TObject);
    procedure ItalicClick(Sender: TObject);
    procedure UnderlinedClick(Sender: TObject);
    procedure FontSizeKeyPress(Sender: TObject; var Key: Char);
    procedure CancelClick(Sender: TObject);
    procedure ApplyClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure BgColorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainSet	:TMainSet;
implementation

uses Main;

{$R *.DFM}
//-----------------------------------------------------------------------------
                                    //!!!
procedure TMainSet.FormCreate(Sender: TObject);  //    ComboBox
var i:integer;
begin
  for i:=0 to Screen.Fonts.Count-1 do
    begin
      FontBoX.Items.Add(Screen.Fonts[i])
    end;
end;

procedure TMainSet.FormShow(Sender: TObject);
begin
  WinPos.Checked:=MainF.Reg.ReadBool('SWinP');
  Bak.Checked:=MainF.Reg.ReadBool('Bak');
//---
  FontBox.ItemIndex:=FontBox.Items.IndexOF(MainF.Edit.Font.Name);
  FontColor.Color:=MainF.Edit.Font.Color;
  FontSize.Text:=IntToStr(MainF.Edit.Font.Size);
  if fsBold in MainF.Edit.Font.Style then Bold.Checked:=true else Bold.Checked:=false;
  if fsItalic in MainF.Edit.Font.Style then Italic.Checked:=true else Italic.Checked:=false;
  if fsUnderline in MainF.Edit.Font.Style then Underlined.Checked:=true else Underlined.checked:=false;
  Example.Font:=MainF.Edit.Font;
//---
  BgColor.Color:=MainF.Edit.Color;
end;

procedure TMainSet.FontBoxChange(Sender: TObject);
begin
  Example.Font.Name:=FontBox.Text
end;

procedure TMainSet.FontColorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog.Color:=FontColor.color;
  if ColorDialog.Execute then
    begin
      FontColor.Color:=ColorDialog.Color;
      if FontColor.Color<16777215 div 2 then FontColor.Font.Color:=clNone
          else FontColor.Font.Color:=clBlack;
      Example.Font.Color:=ColorDialog.Color
    end;
end;

procedure TMainSet.FontSizeChange(Sender: TObject);
var s:string;
    i,c:integer;
begin
  s:=FontSize.Text;
  c:=FontSize.SelStart;
  if s<>'' then
  begin
    i:=1;
    repeat
      if not(s[i] in ['0'..'9']) then
        begin
          delete(s,i,1);
          dec(i)
        end;
      inc(i);
    until i=length(s)+1;
    FontSize.Text:=S;
    FontSize.SelStart:=c;
  end
end;

procedure TMainSet.UpDownChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  Example.Font.Size:=UpDown.Position
end;

procedure TMainSet.BoldClick(Sender: TObject);
begin
  if Bold.Checked then Example.Font.Style:=Example.Font.Style+[fsBold]
    else
      Example.Font.Style:=Example.Font.Style-[fsBold]
end;

procedure TMainSet.ItalicClick(Sender: TObject);
begin
  if Italic.Checked then Example.Font.Style:=Example.Font.Style+[fsItalic]
    else
      Example.Font.Style:=Example.Font.Style-[fsItalic]
end;

procedure TMainSet.UnderlinedClick(Sender: TObject);
begin
  if Underlined.Checked then Example.Font.Style:=Example.Font.Style+[fsUnderline]
    else
      Example.Font.Style:=Example.Font.Style-[fsUnderline]
end;

procedure TMainSet.FontSizeKeyPress(Sender: TObject; var Key: Char);
var n,c:integer;
label ass;
begin
   if (FontSize.Text<>'')and(ord(key)=13) then
   begin
ass:c:=FontSize.SelStart;
    n:=StrToInt(FontSize.Text);
    if n>36 then
      begin
        n:=36;
        FontSize.Text:='36';
        FontSize.SelStart:=c
      end;
    if n<7 then
      begin
        n:=7;
        FontSize.Text:='7';
        FontSize.SelStart:=c
      end;
    Example.Font.Size:=n
   end
     else
       if FontSize.Text='' then
         begin
           FontSize.Text:='7';
           goto ass
         end
end;
//-----------------------------------------------------------------------------
   			//  
procedure TMainSet.BgColorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog.Color:=BgColor.Color;
  if ColorDialog.Execute then
     begin
      BgColor.Color:=ColorDialog.Color;
      if BgColor.Color<16777215 div 2 then BgColor.Font.Color:=clNone
          else BgColor.Font.Color:=clBlack;
     end
end;
procedure TMainSet.CancelClick(Sender: TObject);
begin
  Close
end;

procedure TMainSet.ApplyClick(Sender: TObject);
var c:char;
begin
  c:=chr(13);
  FontSizeKeyPress(Sender,c);
  MainF.Edit.Font:=Example.Font;
  MainF.Edit.Color:=BgColor.Color;
//-------------------------------
try
  MainF.Reg.WriteBool('SWinP',WinPos.Checked);
  MainF.Reg.WriteBool('Bak',Bak.Checked);
except
  raise
end
end;

procedure TMainSet.OKClick(Sender: TObject);
begin
  ApplyClick(Sender);
  CancelClick(Sender)
end;

end.
