unit UReplaceDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TReplaceDialog = class(TForm)
    FindText: TEdit;
    ReplaceText: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    reg: TCheckBox;
    WholeWord: TCheckBox;
    Find: TButton;
    Replace: TButton;
    ReplaceAll: TButton;
    Cancel: TButton;
    procedure Execute;
    procedure FindClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelClick(Sender: TObject);
    procedure ReplaceClick(Sender: TObject);
    procedure ReplaceAllClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private

  public
    EndType: byte;
  end;

var
  ReplaceDialog :TReplaceDialog;
  FDreg,
  FDWW		:boolean;
  FDFT		:string;
implementation

uses UFindDialog, Main;

{$R *.DFM}
procedure TReplaceDialog.Execute;
begin
  position:=poMainFormCenter;
  FDreg:=FindDialog.reg.checked;
  FDWW:=FindDialog.WholeWord.checked;
  FDFT:=FinDDialog.FindText.Text;
  ShowModal
end;

procedure TReplaceDialog.FindClick(Sender: TObject);
begin
  FindDialog.CanFind:=true;
  FinDdialog.FindText.Text:=FindText.Text;
  FindDialog.reg.checked:=reg.checked;
  FindDialog.WholeWord.Checked:=WholeWord.Checked;
  MainF.FindMoreExecute(Sender)
end;

procedure TReplaceDialog.ReplaceClick(Sender: TObject);
begin
  if MainF.Edit.SelLength<>0 then
      MainF.Edit.SelText:=ReplaceText.Text;
end;

procedure TReplaceDialog.ReplaceAllClick(Sender: TObject);
var c:longint;
begin
  c:=MainF.Edit.Selstart;
  MainF.Edit.SelStart:=0;
  repeat
    FindClick(Sender);
    ReplaceClick(Sender)
  until not FindDialog.CanFind;
  MainF.Edit.SelStart:=c;
  Close
end;

procedure TReplaceDialog.CancelClick(Sender: TObject);
begin
  Close;
end;

procedure TReplaceDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FindDialog.FindText.Text:=FDFT;
  FindDialog.reg.Checked:=FDreg;
  FindDialog.WholeWord.Checked:=FDWW;
end;

procedure TReplaceDialog.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then FindClick(Sender)
    else
  if key=#27 then CancelClick(Sender)
end;

end.
